## libvidstab 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (vid.stab)

SET(CMAKE_BUILTTYPE None)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

include (FindSSE)

set(MAJOR_VERSION 1)
set(MINOR_VERSION 1)
set(PATCH_VERSION 0)
set(VIDSTAB_VERSION ${MAJOR_VERSION}.${MINOR_VERSION}${PATCH_VERSION})

option(BUILD_SHARED_LIBS "build shared libraries instead of static libraries"
       ON)

option(USE_OMP "use parallelization use OMP" ON)

# determine lib suffix
get_property(LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (LIB64 STREQUAL "TRUE")
    set(LIBSUFFIX 64)
else()
    set(LIBSUFFIX "")
endif()

add_definitions( -Wall -O3 -g -Wno-pointer-sign -fPIC -std=gnu99)
# add_definitions(  -Wall -O0 -g -Wno-pointer-sign )

### ORC is not used in any active code at the moment  ###
# I tried it with 0.4.14
#  0.4.10 did not work (not all opcode implemented)
# find_package(Orc)
if(ORC_FOUND)
add_definitions( -DUSE_ORC ${ORC_DEFINITIONS} )
include_directories( ${ORC_INCLUDE_DIRS} )
else()
add_definitions( -DDISABLE_ORC )
endif()

# here we should check for SSE2
# our  -DUSE_SSE2_ASM code does not work with fpic
if(SSE2_FOUND)
add_definitions( -DUSE_SSE2 -msse2 -ffast-math )
endif()

if(USE_OMP)
add_definitions(-fopenmp -DUSE_OMP)
endif()

set(SOURCES src/frameinfo.c src/transformtype.c src/libvidstab.c
  src/transform.c src/transformfixedpoint.c src/motiondetect.c
  src/motiondetect_opt.c src/serialize.c src/localmotion2transform.c
  src/boxblur.c src/vsvector.c src/orc/motiondetectorc.c)

set(HEADERS src/frameinfo.h src/transformtype.h src/libvidstab.h
  src/transform.h src/motiondetect.h src/serialize.h
  src/localmotion2transform.h src/boxblur.h src/vsvector.h )


# Create the vidstab library
add_library (vidstab ${SOURCES})

#set version of lib
set_target_properties(vidstab PROPERTIES SOVERSION ${MAJOR_VERSION}.${MINOR_VERSION})


target_link_libraries(vidstab m)
set(PKG_EXTRA_LIBS -lm)
if(ORC_FOUND)
target_link_libraries(vidstab ${ORC_LIBRARIES})
set(PKG_EXTRA_LIBS "${PKG_EXTRA_LIBS} ${ORC_LIBRARIES}")
endif()
if(USE_OMP)
target_link_libraries(vidstab gomp)
set(PKG_EXTRA_LIBS "${PKG_EXTRA_LIBS} -lgomp")
endif()


#if(!NOHEADERS)
FILE(GLOB HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/src/*.h")
INSTALL(FILES ${HEADERS} DESTINATION include/vid.stab)
#endif()

INSTALL(TARGETS vidstab
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  ARCHIVE DESTINATION lib${LIB_SUFFIX}
)

include(create_pkgconfig_file)
create_pkgconfig_file(vidstab "Vid.Stab, a library for stabilizing video clips")

=== tests/CMakeLists.txt ===
# to use intel compiler: cd cmake; CC=icc CXX=icpc cmake ../
#  very fast: faster than orc code at imgcompare without any options.
#  library needs libimf.so (link statically?)

cmake_minimum_required (VERSION 2.6)
project (vid.stab)

SET(CMAKE_BUILTTYPE None)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/../CMakeModules/")

option(USE_OMP "use parallelization use OMP" ON)

#add_definitions( -Wall -O3 -Wno-pointer-sign -DTESTING  -std=gnu99)
add_definitions(  -Wall -O0 -g -Wno-pointer-sign -DTESTING -std=gnu99)
find_package(Orc)
if(ORC_FOUND)
add_definitions( -DUSE_ORC ${ORC_DEFINITIONS})
include_directories( ${ORC_INCLUDE_DIRS} )
else()
add_definitions( -DDISABLE_ORC)
endif()

add_definitions( -DUSE_SSE2 -msse2 -ffast-math -fno-show-column ) # -DUSE_SSE2_ASM

if(USE_OMP)
add_definitions(-fopenmp -DUSE_OMP)
endif()

# Make sure the compiler can find include files from transcode
include_directories (../src)

add_executable (tests tests.c testutils.c testframework.c ../src/vsvector.c
  ../src/transform.c ../src/transformfloat.c ../src/transformfixedpoint.c
  ../src/libvidstab.c ../src/transformtype.c ../src/frameinfo.c
  ../src/serialize.c ../src/localmotion2transform.c
  ../src/motiondetect.c ../src/motiondetect_opt.c ../src/orc/motiondetectorc.c ../src/boxblur.c)

target_link_libraries(tests m)
if(ORC_FOUND)
target_link_libraries(tests ${ORC_LIBRARIES})
endif()
if(USE_OMP)
target_link_libraries(tests gomp)
endif()

=== transcode/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (vid.stab.transcode)

SET(CMAKE_BUILTTYPE None)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/../CMakeModules/")

# set your transcode path here!
set(TRANSCODE_ROOT ../../transcode)


add_definitions( -Wall -O3 -Wno-pointer-sign -DTRANSCODE -std=gnu99)
#add_definitions(  -Wall -O0 -g -Wno-pointer-sign )
# I tried it with 0.4.14
#  0.4.10 did not work (not all opcode implemented)
# find_package(Orc)  // it actually not used by any active code
if(ORC_FOUND)
add_definitions( -DUSE_ORC ${ORC_DEFINITIONS} )
include_directories( ${ORC_INCLUDE_DIRS} )
else()
add_definitions( -DDISABLE_ORC )
endif()

# here we should check for SSE2
# our  -DUSE_SSE2_ASM code does not work with fpic
add_definitions( -DUSE_SSE2 -msse2 -ffast-math )

# Make sure the compiler can find include files from transcode
include_directories (../src ${TRANSCODE_ROOT}/src ${TRANSCODE_ROOT}/ )

# Create the stabilize and transform libraries
add_library (filter_transform SHARED filter_transform.c
  ../src/transformtype.c ../src/libvidstab.c ../src/transform.c
  ../src/transformfixedpoint.c  ../src/vsvector.c ../src/serialize.c ../src/frameinfo.c
	../src/localmotion2transform.c) #  orc/transformorc.c)
add_library (filter_stabilize SHARED filter_stabilize.c
  ../src/transformtype.c ../src/libvidstab.c ../src/motiondetect.c
	../src/orc/motiondetectorc.c ../src/motiondetect_opt.c ../src/localmotion2transform.c
  ../src/boxblur.c ../src/vsvector.c ../src/serialize.c  ../src/frameinfo.c)
add_library (filter_deshake SHARED filter_deshake.c
  ../src/transformtype.c ../src/libvidstab.c ../src/motiondetect.c
  ../src/orc/motiondetectorc.c ../src/boxblur.c ../src/transform.c ../src/motiondetect_opt.c
  ../src/transformfixedpoint.c ../src/vsvector.c ../src/serialize.c ../src/frameinfo.c
	../src/localmotion2transform.c)


set_target_properties(filter_stabilize PROPERTIES  PREFIX "" )
set_target_properties(filter_transform PROPERTIES  PREFIX "" )
set_target_properties(filter_deshake   PROPERTIES  PREFIX "" )

target_link_libraries(filter_stabilize m )
target_link_libraries(filter_transform m )
target_link_libraries(filter_deshake   m )

if(ORC_FOUND)
target_link_libraries(filter_stabilize ${ORC_LIBRARIES} )
target_link_libraries(filter_transform ${ORC_LIBRARIES} )
target_link_libraries(filter_deshake   ${ORC_LIBRARIES} )
endif()
if(USE_OMP)
target_link_libraries(filter_stabilize gomp )
target_link_libraries(filter_transform gomp )
target_link_libraries(filter_deshake   gomp )
endif()

=== src/orc/Makefile ===

all: motiondetectorc.c motiondetectorc.h transformorc.c transformorc.h

motiondetectorc.c : motiondetectorc.orc
	orcc --implementation -o motiondetectorc.c motiondetectorc.orc

motiondetectorc.h : motiondetectorc.orc
	orcc --header -o motiondetectorc.h motiondetectorc.orc

transformorc.c : transformorc.orc
	orcc --implementation -o transformorc.c transformorc.orc

transformorc.h : transformorc.orc
	orcc --header -o transformorc.h transformorc.orc

=== debian/changelog ===
libvidstab (1.1.0-2) unstable; urgency=low

  [James Cowgill]
  * Enable Multi-Arch: same in debian/control (Closes: #909380)

  [Helmut Grohne]
  * Explicitly choose where to use -msse2. (Closes: #910100)
    - Currently only AMD64

 -- Keng-Yu Lin <kengyu@lexical.tw>  Sun, 14 Oct 2018 01:27:10 +0800

libvidstab (1.1.0-1) unstable; urgency=low

  * Upstream release 1.1.0 (Closes: #709193)

 -- Keng-Yu Lin <kengyu@lexical.tw>  Wed, 01 Aug 2018 14:39:07 +0800

libvidstab (1.0.0-1) unstable; urgency=medium

  * debian/rules: Add changes that will be dropped for next upstream version.
  * New upstream version 0.98
  * debian/{compat,control}: Update debhelper compat to 10.
  * debian/control:
    + Add upstream homepage.
    + Add Vcs-* fields.
    + Add proper short and long descriptions.
    + Fix SONAME in shared library.
    + Add misc-depends, since we are using debhelper.
    + Remove redundant field from previous packaging versions.
  * debian:
    + Normalize with `wrap-and-sort -s -a -v`.
  * debian/rules:
    + Fix grave bug with respect to spaces vs. tab on makefile.
    + Ignore the custom rules for the moment.
  * debian/libvidstab*.install: Rename to be consistent with SONAME.
  * debian/watch:
    + Update to version 4 to fix detection of new releases.
  * New upstream version 1.0.0
  * debian/docs:
    + Change from README to README.md to follow upstream.
  * debian/{control,libvidstat1.1.install}:
    + Fix for new SONAME.

 -- Rogério Brito <rbrito@ime.usp.br>  Wed, 07 Jun 2017 19:47:43 -0300

=== debian/control ===
Source: libvidstab
Priority: optional
Maintainer: Keng-Yu Lin <kengyu@lexical.tw>
Build-Depends:
 cmake,
 debhelper (>= 10.2.1)
Standards-Version: 4.1.5
Section: libs
Homepage: http://public.hronopik.de/vid.stab/

Package: libvidstab-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libvidstab1.1 (= ${binary:Version})
Description: video stabilization library (development files)
 Imagine you captured a nice video with your camcorder, compact camera or
 even cell phone while skiing, cycling or whatever sports and the video is
 basically just jiggled.
 .
 Modern cameras come along with hardware stabilisation, however this does
 not work if you have really strong vibrations - rather the contrary -
 sometimes this mechanism starts to oscillate.
 .
 Vid.Stab is your friend in this matter. It is designed to stabilize even
 strongly jiggled clips.
 .
 This package contains the development files of vid.stab.

Package: libvidstab1.1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Pre-Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Description: video stabilization library (shared library)
 Imagine you captured a nice video with your camcorder, compact camera or
 even cell phone while skiing, cycling or whatever sports and the video is
 basically just jiggled.
 .
 Modern cameras come along with hardware stabilisation, however this does
 not work if you have really strong vibrations - rather the contrary -
 sometimes this mechanism starts to oscillate.
 .
 Vid.Stab is your friend in this matter. It is designed to stabilize even
 strongly jiggled clips.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
ifeq ($(DEB_HOST_ARCH_CPU),amd64)
HAVE_SSE2=ON
else
HAVE_SSE2=OFF
endif

%:
	dh $@

override_dh_auto_configure:
		dh_auto_configure -- -DSSE2_FOUND=$(HAVE_SSE2)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%vid.stab-$1.tar.gz%" \
    https://github.com/georgmartius/vid.stab/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
